#include "m3kte.h"
#include "ui_m3kte.h"

#include "settingsdialog.h"
#include "writeregistermodel.h"

#include <QModbusTcpClient>
#include <QModbusRtuSerialMaster>
#include <QStandardItemModel>
#include <QStatusBar>
#include <QUrl>

//1024 768
//Ширина колбы - уже
M3KTE::M3KTE(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::M3KTE)
{
    ui->setupUi(this);

    //Массив указателей на индикаторы напряжения топливных элементов
    {
        int i = 0;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_1;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_2;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_3;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_4;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_5;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_6;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_7;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_8;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_9;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_10;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_11;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_12;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_13;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_14;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_15;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_16;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_17;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_18;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_19;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_20;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_21;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_22;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_23;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_24;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_25;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_26;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_27;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_28;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_29;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_30;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_31;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_32;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_33;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_34;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_35;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_36;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_37;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_38;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_39;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_40;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_41;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_42;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_43;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_44;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_45;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_46;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_47;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_48;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_49;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_50;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_51;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_52;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_53;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_54;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_55;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_56;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_57;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_58;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_59;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_60;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_61;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_62;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_63;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_64;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_65;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_66;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_67;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_68;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_69;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_70;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_71;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_72;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_73;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_74;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_75;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_76;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_77;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_78;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_79;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_80;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_81;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_82;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_83;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_84;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_85;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_86;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_87;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_88;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_89;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_90;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_91;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_92;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_93;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_94;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_95;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_96;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_97;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_98;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_99;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_100;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_101;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_102;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_103;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_104;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_105;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_106;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_107;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_108;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_109;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_110;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_111;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_112;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_113;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_114;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_115;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_116;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_117;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_118;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_119;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_120;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_121;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_122;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_123;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_124;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_125;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_126;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_127;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_128;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_129;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_130;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_131;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_132;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_133;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_134;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_135;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_136;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_137;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_138;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_139;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_140;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_141;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_142;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_143;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_144;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_145;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_146;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_147;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_148;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_149;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_150;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_151;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_152;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_153;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_154;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_155;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_156;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_157;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_158;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_159;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_160;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_161;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_162;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_163;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_164;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_165;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_166;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_167;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_168;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_169;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_170;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_171;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_172;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_173;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_174;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_175;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_176;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_177;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_178;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_179;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_180;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_181;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_182;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_183;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_184;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_185;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_186;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_187;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_188;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_189;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_190;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_191;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_192;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_193;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_194;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_195;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_196;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_197;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_198;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_199;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_200;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_201;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_202;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_203;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_204;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_205;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_206;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_207;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_208;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_209;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_210;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_211;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_212;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_213;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_214;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_215;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_216;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_217;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_218;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_219;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_220;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_221;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_222;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_223;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_224;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_225;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_226;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_227;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_228;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_229;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_230;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_231;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_232;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_233;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_234;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_235;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_236;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_237;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_238;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_239;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_240;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_241;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_242;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_243;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_244;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_245;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_246;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_247;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_248;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_249;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_250;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_251;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_252;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_253;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_254;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_255;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_256;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_257;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_258;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_259;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_260;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_261;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_262;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_263;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_264;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_265;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_266;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_267;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_268;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_269;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_270;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_271;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_272;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_273;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_274;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_275;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_276;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_277;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_278;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_279;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_280;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_281;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_282;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_283;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_284;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_285;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_286;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_287;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_288;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_289;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_290;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_291;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_292;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_293;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_294;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_295;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_296;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_297;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_298;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_299;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_300;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_301;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_302;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_303;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_304;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_305;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_306;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_307;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_308;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_309;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_310;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_311;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_312;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_313;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_314;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_315;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_316;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_317;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_318;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_319;
        m_ProgressBar[i++] = ui->FuelCellVoltageBar_320;
    }


    m_settingsDialog = new SettingsDialog(this);

    ui->writeTable->addItem(tr("Exceptions"), QModbusDataUnit::Coils);
    ui->writeTable->addItem(tr("Warnings"), QModbusDataUnit::HoldingRegisters);
    ui->writeTable->addItem(tr("Accidents"), QModbusDataUnit::HoldingRegisters);

    for(int i = 0; i < 4; i++)
    {
        Boards[i].ModbusModelCoil = new WriteRegisterModel(this, 85 - (i/3*20), false);
        Boards[i].ModbusModelCoil->setStartAddress(0);
        Boards[i].ModbusModelCoil->setNumberOfValues(QString::number(85-(i/3*20)));
        Boards[i].ModbusModelHoldingReg = new WriteRegisterModel(this, (85 - (i/3*20))*2, true);
        Boards[i].ModbusModelHoldingReg->setStartAddress(0);
        Boards[i].ModbusModelHoldingReg->setNumberOfValues(QString::number(85-(i/3*20)));
    }

    m_deviceSettingsDialog = new DeviceSettingsDialog(this);
    m_regMultipleSettings = new MultipleSettings(this);

    modbusDevice = new QModbusRtuSerialMaster(this);
    //ui->M3kteRegSettings->setEnabled(false);

    Boards[0].boardScanners = new QTimer();
    Boards[1].boardScanners = new QTimer();
    Boards[2].boardScanners = new QTimer();
    Boards[3].boardScanners = new QTimer();

    Boards[0].boardScanners->setSingleShot(true);
    Boards[1].boardScanners->setSingleShot(true);
    Boards[2].boardScanners->setSingleShot(true);
    Boards[3].boardScanners->setSingleShot(true);

    connect(Boards[0].boardScanners, &QTimer::timeout, this, &M3KTE::firstBoardScan);
    connect(Boards[1].boardScanners, &QTimer::timeout, this, &M3KTE::secondBoardScan);
    connect(Boards[2].boardScanners, &QTimer::timeout, this, &M3KTE::thirdBoardScan);
    connect(Boards[3].boardScanners, &QTimer::timeout, this, &M3KTE::fourthBoardScan);

    Boards[0].adr = 1;
    Boards[1].adr = 2;
    Boards[2].adr = 3;
    Boards[3].adr = 4;

    ui->BSM_Warning->setEnabled(false);
    ui->BSM_Accident->setEnabled(false);
    ui->BSM_WorkInProgress->setEnabled(false);

    initActions();

    ui->BST_Off->setChecked(true);

    ui->boardSelectBox->setCurrentIndex(0);
    ui->writeTable->setCurrentIndex(0);
    changeTable(0, 0);

    for (int i = 0; i < 4; i++) {
        statusM3KTE.Warnings[i] = false;
        statusM3KTE.Accidents[i] = false;
    }

    QBrush tb(Qt::transparent); // Transparent brush, solid pattern
    for(int i = 0; i<320; i++)
    {
        m_ProgressBar[i]->setValue(3);
        QString style_fc_off = "QProgressBar {border: 2px solid black; font: bold 10px} QProgressBar::chunk {background: hsva(" + QString::number(30) + ", 30, 30, 30%);} ";
        m_ProgressBar[i]->setStyleSheet(style_fc_off);

        ThePhantomMenace[i] = new QPushButton(m_ProgressBar[i]);
        ThePhantomMenace[i]->setFlat(true);
        ThePhantomMenace[i]->setPalette(QPalette(tb, tb, tb, tb, tb, tb, tb, tb, tb));
        connect(ThePhantomMenace[i], &QPushButton::clicked, this, [this, i]() {
           selectPositionOnTree(i);
        });
    }
    debug();

    connect(m_deviceSettingsDialog, &DeviceSettingsDialog::parityChanged, this, &M3KTE::onParityUpdate);
    connect(m_deviceSettingsDialog, &DeviceSettingsDialog::speedChanged, this, &M3KTE::onSpeedUpdate);


    //Вызов окна настройки подключения

    //Вызов окна настройки устройства

}

M3KTE::~M3KTE()
{
    if(modbusDevice->state() == QModbusDevice::ConnectedState)
    {
        onConnectClicked();
    }
    delete ui;
}

void M3KTE::debug()
{
    srand(time(0));
    for(int i = 0; i < 320; i++)
    {
        m_ProgressBar[i]->setTextVisible(true);
        m_ProgressBar[i]->setMinimumSize(25, 25);
        m_ProgressBar[i]->setMaximumSize(25, 25);
        m_ProgressBar[i]->resize(25, 25);
        m_ProgressBar[i]->setAlignment(Qt::AlignCenter);
        m_ProgressBar[i]->setFormat(QString("%1").arg((i%85+1)));
//        int j = rand()%4;
//        if(j!=3) j=rand()%4;
//        m_ProgressBar[i]->setValue(j);
//        QString style_fc = "QProgressBar {border: 2px solid black; font: bold 10px} QProgressBar::chunk {background: hsva(" + QString::number(j*50-50) + ", 255, 255, 100%);} ";
//        QString style_fc_off = "QProgressBar {border: 2px solid black; font: bold 10px} QProgressBar::chunk {background: hsva(" + QString::number(30) + ", 30, 30, 30%);} ";
//        m_ProgressBar[i]->setStyleSheet(style_fc);

//        switch (j) {
//        case 1:
//        {
//            m_ProgressBar[i]->setStatusTip(QString("П%1 ТЭ%2: Аварийный уровень напряжения.").arg(QString::number(i/85+1), QString::number(i%85)));
//            break;
//        }
//        case 2:
//        {
//            m_ProgressBar[i]->setStatusTip(QString("П%1 ТЭ%2: Предупредительный уровень напряжения.").arg(QString::number(i/85+1), QString::number(i%85)));
//            break;
//        }
//        case 3:
//        {
//            m_ProgressBar[i]->setStatusTip(QString("П%1 ТЭ%2: Уровень напряжения в норме.").arg(QString::number(i/85+1), QString::number(i%85)));
//            break;
//        }
//        case 0:
//            m_ProgressBar[i]->setStatusTip(QString("П%1 ТЭ%2: Топливный Элемент не учитывается.").arg(QString::number(i/85+1), QString::number(i%85)));
//            m_ProgressBar[i]->setStyleSheet(style_fc_off);
//            m_ProgressBar[i]->setValue(3);
//            break;
//        }
    }
}


void M3KTE::initActions()
{
    ui->ConnectionMenuConnect->setEnabled(true);
    ui->ConnectionMenuDisconnect->setEnabled(false);
    ui->ConnectionMenuSettings->setEnabled(true);

    connect(ui->ConnectionMenuConnect, &QAction::triggered,
            this, &M3KTE::onConnectClicked);
    connect(ui->ConnectionMenuDisconnect, &QAction::triggered,
            this, &M3KTE::onConnectClicked);
    connect(ui->readButton, &QPushButton::clicked,
            this, &M3KTE::onReadButtonClicked);
    connect(ui->writeButton, &QPushButton::clicked,
            this, &M3KTE::onWriteButtonClicked);
    connect(ui->boardSelectBox, QOverload<int>::of(&QComboBox::currentIndexChanged),
            this, &M3KTE::onSelectedBoardChanged);
    connect(ui->writeTable, QOverload<int>::of(&QComboBox::currentIndexChanged),
            this, &M3KTE::onWriteTableChanged);

    connect(ui->M3kteRegSettings, &QAction::triggered, m_regMultipleSettings, &QDialog::show);
    connect(m_regMultipleSettings, &MultipleSettings::write, this, &M3KTE::slotmultipleRegWrite);
    connect(m_regMultipleSettings, &MultipleSettings::writeAndSend, this, &M3KTE::slotmultipleRegWriteAndSend);

    connect(ui->ConnectionMenuSettings, &QAction::triggered, m_settingsDialog, &QDialog::show);
    connect(ui->M3kteMenuSettings, &QAction::triggered, m_deviceSettingsDialog, &QDialog::show);
}

void M3KTE::onConnectClicked()
{
    if (!modbusDevice)
        return;

    statusBar()->clearMessage();
    if (modbusDevice->state() != QModbusDevice::ConnectedState) {
            modbusDevice->setConnectionParameter(QModbusDevice::SerialPortNameParameter,
                m_settingsDialog->settings().portName);
#if QT_CONFIG(modbus_serialport)
            modbusDevice->setConnectionParameter(QModbusDevice::SerialParityParameter,
                m_settingsDialog->settings().parity);
            modbusDevice->setConnectionParameter(QModbusDevice::SerialBaudRateParameter,
                m_settingsDialog->settings().baud);
            modbusDevice->setConnectionParameter(QModbusDevice::SerialDataBitsParameter,
                m_settingsDialog->settings().dataBits);
            modbusDevice->setConnectionParameter(QModbusDevice::SerialStopBitsParameter,
                m_settingsDialog->settings().stopBits);
#endif
        modbusDevice->setTimeout(m_settingsDialog->settings().responseTime);
        modbusDevice->setNumberOfRetries(m_settingsDialog->settings().numberOfRetries);
        if (!modbusDevice->connectDevice()) {
            statusBar()->showMessage(tr("Connect failed: ") + modbusDevice->errorString(), 5000);
        } else {
            ui->ConnectionMenuConnect->setEnabled(false);
            ui->ConnectionMenuDisconnect->setEnabled(true);

            if(pingNetworkDevices())
            {
                unsigned tmp_adr[4];
                for (int i = 0; i < 4; i++) {
                    tmp_adr[i] = Boards[i].adr;
                }

                ui->M3kteRegSettings->setEnabled(true);

                m_deviceSettingsDialog->updateSettingsAfterConnection(m_settingsDialog->settings().baud, m_settingsDialog->settings().parity, tmp_adr, CurrentConnectedDevice);

                ui->boardSelectBox->setCurrentIndex(0);
                ui->writeTable->setCurrentIndex(0);
                changeTable(0, 0);

                ui->BST_Off->setChecked(false);
                ui->BST_On->setChecked(true);

                ui->BSM_Warning->setEnabled(true);
                ui->BSM_Accident->setEnabled(true);
                ui->BSM_WorkInProgress->setEnabled(true);
                ui->BSM_WorkInProgress->setChecked(true);
            }
            //Опрос устройств
        }
    } else {
        QString style_fc_off = "QProgressBar {border: 2px solid black; font: bold 10px} QProgressBar::chunk {background: hsva(" + QString::number(30) + ", 30, 30, 30%);} ";
        for(int i = 0; i < 4; i++)
        {
            Boards[i].boardScanners->stop();
        }
        for(int i = 0; i < 320; i++)
        {
            m_ProgressBar[i]->setStatusTip(QString("П%1 ТЭ%2: Топливный Элемент не учитывается.").arg(QString::number(i/85+1), QString::number(i%85)));
            m_ProgressBar[i]->setWhatsThis(QString("П%1 ТЭ%2: Топливный Элемент не учитывается.").arg(QString::number(i/85+1), QString::number(i%85)));
            m_ProgressBar[i]->setValue(3);
            m_ProgressBar[i]->setStyleSheet(style_fc_off);
        }

        modbusDevice->disconnectDevice();
        ui->ConnectionMenuConnect->setEnabled(true);
        ui->ConnectionMenuDisconnect->setEnabled(false);
        ui->BST_Off->setChecked(true);
        ui->BST_On->setChecked(false);

        ui->BSM_Warning->setChecked(false);
        ui->BSM_Accident->setChecked(false);
        ui->BSM_WorkInProgress->setChecked(false);

        ui->BSM_Warning->setEnabled(false);
        ui->BSM_Accident->setEnabled(false);
        ui->BSM_WorkInProgress->setEnabled(false);

        ui->M3kteRegSettings->setEnabled(false);
    }
}

void M3KTE::onReadButtonClicked()
{
    if (!modbusDevice)
        return;
    //ui->readValue->clear();
    statusBar()->clearMessage();


    if (auto *reply = modbusDevice->sendReadRequest(readRequest(), Boards[ui->boardSelectBox->currentIndex()].adr)) {
        if (!reply->isFinished())
            connect(reply, &QModbusReply::finished, this, &M3KTE::onReadReady);
        else
            delete reply; // broadcast replies return immediately
    } else {
        statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
    }
//    if (auto *reply = modbusDevice->sendReadRequest(readRequest(), ui->serverEdit->value())) {
//        if (!reply->isFinished())
//            connect(reply, &QModbusReply::finished, this, &M3KTE::onReadReady);
//        else
//            delete reply; // broadcast replies return immediately
//    } else {
//        statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
//    }
//    if (auto *reply = modbusDevice->sendReadRequest(readRequest(), ui->serverEdit->value())) {
//        if (!reply->isFinished())
//            connect(reply, &QModbusReply::finished, this, &M3KTE::onReadReady);
//        else
//            delete reply; // broadcast replies return immediately
//    } else {
//        statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
//    }
}

void M3KTE::onReadReady()
{
    auto reply = qobject_cast<QModbusReply *>(sender());
    if (!reply)
        return;

    if (reply->error() == QModbusDevice::NoError) {
        const QModbusDataUnit unit = reply->result();
        int Adr = 255;
        for(int i = 0; i < CurrentConnectedDevice; i++)
        {
            if(Boards[i].adr==reply->serverAddress())
            {
                Adr = i;
                break;
            }
        }
        for (int i = 0, total = int(unit.valueCount()); i < total; ++i) {
            //ui->readValue->addItem(entry);
            if(unit.registerType() == QModbusDataUnit::Coils)
            {
                //QStandardItem *item = ui->writeValueTable->model()->item
                Boards[Adr].coil[i + unit.startAddress()] = unit.value(i);
                if(unit.value(i)==1)
                    Boards[Adr].ModbusModelCoil->setData(ui->writeValueTable->model()->index(i + unit.startAddress(), 2), Qt::Checked, Qt::CheckStateRole);
                else
                   Boards[Adr].ModbusModelCoil->setData(ui->writeValueTable->model()->index(i + unit.startAddress(), 2), Qt::Unchecked, Qt::CheckStateRole);
            }
            else if(unit.registerType() == QModbusDataUnit::HoldingRegisters)
            {
                Boards[Adr].HR[i + unit.startAddress()] = unit.value(i);
                Boards[Adr].ModbusModelHoldingReg->setData(ui->writeValueTable->model()->index(i + unit.startAddress(), 3), QString::number(unit.value(i), 16), Qt::EditRole);
            }
        }
    } else if (reply->error() == QModbusDevice::ProtocolError) {
        statusBar()->showMessage(tr("Read response error: %1 (Mobus exception: 0x%2)").
                                    arg(reply->errorString()).
                                    arg(reply->rawResult().exceptionCode(), -1, 16), 5000);
    } else {
        statusBar()->showMessage(tr("Read response error: %1 (code: 0x%2)").
                                    arg(reply->errorString()).
                                    arg(reply->error(), -1, 16), 5000);
    }

    reply->deleteLater();
}

void M3KTE::onWriteButtonClicked()
{
    if (!modbusDevice)
        return;
    statusBar()->clearMessage();

    QModbusDataUnit writeUnit = writeRequest();
    QModbusDataUnit::RegisterType table = writeUnit.registerType();
    for (int i = 0, total = int(writeUnit.valueCount()); i < total; ++i) {
        if (table == QModbusDataUnit::Coils)
        {
            Boards[ui->boardSelectBox->currentIndex()].coil[i+writeUnit.startAddress()] = Boards[ui->boardSelectBox->currentIndex()].ModbusModelCoil->m_coils[i + writeUnit.startAddress()];
            writeUnit.setValue(i, Boards[ui->boardSelectBox->currentIndex()].ModbusModelCoil->m_coils[i + writeUnit.startAddress()]);
        }
        else
        {
            Boards[ui->boardSelectBox->currentIndex()].HR[i+writeUnit.startAddress()] = Boards[ui->boardSelectBox->currentIndex()].ModbusModelHoldingReg->m_holdingRegisters[i+writeUnit.startAddress()];
            writeUnit.setValue(i, Boards[ui->boardSelectBox->currentIndex()].ModbusModelHoldingReg->m_holdingRegisters[i + writeUnit.startAddress()]);
        }
    }

    if (auto *reply = modbusDevice->sendWriteRequest(writeUnit, Boards[ui->boardSelectBox->currentIndex()].adr)) {
        if (!reply->isFinished()) {
            connect(reply, &QModbusReply::finished, this, [this, reply]() {
                if (reply->error() == QModbusDevice::ProtocolError) {
                    statusBar()->showMessage(tr("Write response error: %1 (Mobus exception: 0x%2)")
                        .arg(reply->errorString()).arg(reply->rawResult().exceptionCode(), -1, 16),
                        5000);
                } else if (reply->error() != QModbusDevice::NoError) {
                    statusBar()->showMessage(tr("Write response error: %1 (code: 0x%2)").
                        arg(reply->errorString()).arg(reply->error(), -1, 16), 5000);
                }   
                reply->deleteLater();
            });
        } else {
            // broadcast replies return immediately
            reply->deleteLater();
        }
    } else {
        statusBar()->showMessage(tr("Write error: ") + modbusDevice->errorString(), 5000);
    }
}

void M3KTE::onSelectedBoardChanged(int index)
{
    changeTable(index, ui->writeTable->currentIndex());
}

void M3KTE::onWriteTableChanged(int index)
{
    changeTable(ui->boardSelectBox->currentIndex(), index);
}

void M3KTE::changeTable(int board, int tabletype)
{

    if(tabletype==0)
    {
        ui->writeValueTable->setModel(Boards[board].ModbusModelCoil);
        int i = 0;
        for(;i<Boards[board].ModbusModelHoldingReg->rowCount();i++)
        {
            ui->writeValueTable->setRowHidden(i, ui->writeValueTable->model()->index(i, 0).parent(), false);
        }
        ui->writeValueTable->hideColumn(3);
        ui->writeValueTable->showColumn(2);
    }
    else
    {
        ui->writeValueTable->setModel(Boards[board].ModbusModelHoldingReg);
        if(tabletype==1)
        {
            Boards[board].ModbusModelHoldingReg->setStartAddress(0);
            int i = 0;
            for (;i<Boards[board].ModbusModelHoldingReg->rowCount()/2;i++) {
                ui->writeValueTable->setRowHidden(i, ui->writeValueTable->model()->index(i, 0).parent(), false);
            }
            for(;i<Boards[board].ModbusModelHoldingReg->rowCount();i++)
            {
                ui->writeValueTable->setRowHidden(i, ui->writeValueTable->model()->index(i, 0).parent(), true);
            }
        }
        else
        {
            Boards[board].ModbusModelHoldingReg->setStartAddress(Boards[board].ModbusModelHoldingReg->rowCount()/2);
            int i = 0;
            for (;i<Boards[board].ModbusModelHoldingReg->rowCount()/2;i++) {
                ui->writeValueTable->setRowHidden(i, ui->writeValueTable->model()->index(i, 0).parent(), true);
            }
            for(;i<Boards[board].ModbusModelHoldingReg->rowCount();i++)
            {
                ui->writeValueTable->setRowHidden(i, ui->writeValueTable->model()->index(i, 0).parent(), false);
            }
        }
        ui->writeValueTable->hideColumn(2);
        ui->writeValueTable->showColumn(3);
    }
}

QModbusDataUnit M3KTE::readRequest() const
{
    const auto table =
        static_cast<QModbusDataUnit::RegisterType>(ui->writeTable->currentData().toInt());

    int startAddress = 85 * (ui->writeTable->currentIndex()/2);
    Q_ASSERT(startAddress >= 0 && startAddress < 340);

    // do not go beyond 10 entries
    quint16 numberOfEntries = qMin((ushort)(85 - (ui->boardSelectBox->currentIndex()/3*20)), quint16(340 - startAddress));
    return QModbusDataUnit(table, startAddress, numberOfEntries);
}

QModbusDataUnit M3KTE::writeRequest() const
{
    const auto table =
        static_cast<QModbusDataUnit::RegisterType>(ui->writeTable->currentData().toInt());

    int startAddress = 85 * (ui->writeTable->currentIndex()/2);
    Q_ASSERT(startAddress >= 0 && startAddress < 340);

    // do not go beyond 10 entries
    quint16 numberOfEntries = qMin((ushort)(85 - (ui->boardSelectBox->currentIndex()/3*20)), quint16(340 - startAddress));
    return QModbusDataUnit(table, startAddress, numberOfEntries);
}

bool M3KTE::event(QEvent *event)
{
    if (event->type() == QEvent::User)
    {
        BoardIdHasBeenChanged* _event = static_cast<BoardIdHasBeenChanged*>(event);
        QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::HoldingRegisters, 172, 1);
        _unit->setValue(0, _event->BoardNewID());
        if (auto *reply = modbusDevice->sendWriteRequest(*_unit, Boards[_event->BoardNum()].adr))
        {
            if(!reply->isFinished())
                connect(reply, &QModbusReply::finished, this, [reply, this, _event, _unit]()
                {
                    if(reply->error()==QModbusDevice::TimeoutError)
                    {
                        if (auto *subreply = modbusDevice->sendReadRequest(*_unit, Boards[_event->BoardNum()]._tmp_adr))
                        {
                            if (!subreply->isFinished())
                                connect(subreply, &QModbusReply::finished, this, &M3KTE::checkAdrChange);
                            else
                            {
                                errorAdrChange();
                                delete subreply; // broadcast replies return immediately
                            }
                        } else {
                            errorAdrChange();
                        }
                    }
                    else
                    {
                        errorAdrChange();
                    }
                });
            else
            {
                delete reply;
            }
        }
        else
        {
            errorAdrChange();
        }
//        if (auto *reply = modbusDevice->sendReadRequest(*_unit, Boards[_event->BoardNum()]._tmp_adr))
//        {
//        if (!reply->isFinished())
//            connect(reply, &QModbusReply::finished, this, &M3KTE::checkAdrChange);
//        else
//            delete reply; // broadcast replies return immediately
//        } else {
//            errorAdrChange();
//        }
        m_deviceSettingsDialog->show();
        return true;
    }
    return QWidget::event(event);
}

void M3KTE::checkAdrChange()
{
    auto reply = qobject_cast<QModbusReply *>(sender());
    if (!reply)
    {
        errorAdrChange();
        return;
    }
    if (reply->error() == QModbusDevice::NoError) {
        for (int i = 0; i < CurrentConnectedDevice; i++) {
            if(Boards[i]._tmp_adr == reply->serverAddress())
            {
                //OK
                Boards[i].adr = Boards[i]._tmp_adr;
                    reply->deleteLater();
                return;
            }
        }
        //ERROR
        errorAdrChange();
            reply->deleteLater();
        return;
    }
    errorAdrChange();
    reply->deleteLater();
}

void M3KTE::errorAdrChange()
{
    QMessageBox msgBox;
    msgBox.setText("Не удалось изменить адрес устройства.");
    msgBox.setStandardButtons(QMessageBox::Ok);
    msgBox.setDefaultButton(QMessageBox::Ok);
    int ret = msgBox.exec();
}

void M3KTE::onSpeedUpdate()
{
    //Отсутствие контроля записи регистра на плате.

    QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::HoldingRegisters, 173, 1);
    _unit->setValue(0, m_deviceSettingsDialog->currentSpeed());
    for (int i = 0; i < CurrentConnectedDevice; i++) {
        auto *reply = modbusDevice->sendWriteRequest(*_unit, Boards[i].adr);
        {
        if (!reply->isFinished())
            connect(reply, &QModbusReply::finished, this, [this, reply, i](){
                if(reply->error()==QModbusDevice::TimeoutError)
                {
                    modbusDevice->disconnectDevice();
                    modbusDevice->setConnectionParameter(QModbusDevice::SerialBaudRateParameter,
                                                         m_settingsDialog->UpdateBaud(m_deviceSettingsDialog->currentSpeed()));
                    modbusDevice->connectDevice();
                    QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::InputRegisters, 85, 1);
                    if (auto *subreply = modbusDevice->sendReadRequest(*_unit, Boards[i].adr))
                    {
                        if (!subreply->isFinished())
                            connect(subreply, &QModbusReply::finished, this, [subreply, this, i](){
                                if(subreply->error() != QModbusDevice::NoError)
                                {
                                    QMessageBox msgBox;
                                    msgBox.setText(tr("Не удалось изменить скорость платы %1.").arg(i));
                                    msgBox.setStandardButtons(QMessageBox::Ok);
                                    msgBox.setDefaultButton(QMessageBox::Ok);
                                    int ret = msgBox.exec();
                                }
                            });
                        else
                        {
                            QMessageBox msgBox;
                            msgBox.setText(tr("Не удалось изменить скорость платы %1.").arg(i));
                            msgBox.setStandardButtons(QMessageBox::Ok);
                            msgBox.setDefaultButton(QMessageBox::Ok);
                            int ret = msgBox.exec();
                            delete subreply; // broadcast replies return immediately
                        }
                    } else {
                        QMessageBox msgBox;
                        msgBox.setText(tr("Не удалось изменить скорость платы %1.").arg(i));
                        msgBox.setStandardButtons(QMessageBox::Ok);
                        msgBox.setDefaultButton(QMessageBox::Ok);
                        int ret = msgBox.exec();
                    }

                }
            });
        else
            delete reply; // broadcast replies return immediately
        }
    }


}

void M3KTE::onParityUpdate()
{
    //Отсутствие контроля записи регистра на плате.

    QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::HoldingRegisters, 174, 1);
    switch (m_deviceSettingsDialog->currentParity())
    {
        case 0: //Нет контроля
        {
            _unit->setValue(0, 0x000);
            break;
        }
        case 1: //Четный
        {
            _unit->setValue(0, 0x0400);
            break;
        }
        case 2: //Нечетный
        {
            _unit->setValue(0, 0x0800);
            break;
        }
    }
    for (int i = 0; i < CurrentConnectedDevice; i++) {
        auto *reply = modbusDevice->sendWriteRequest(*_unit, Boards[i].adr);
        {
        if (!reply->isFinished())
            connect(reply, &QModbusReply::finished, this, [this, reply, i](){
                if(reply->error()==QModbusDevice::TimeoutError)
                {
                    modbusDevice->disconnectDevice();
                    modbusDevice->setConnectionParameter(QModbusDevice::SerialParityParameter,
                                                         m_settingsDialog->UpdateParity(m_deviceSettingsDialog->currentParity()));
                    modbusDevice->connectDevice();
                    QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::InputRegisters, 85, 1);
                    if (auto *subreply = modbusDevice->sendReadRequest(*_unit, Boards[i].adr))
                    {
                        if (!subreply->isFinished())
                            connect(subreply, &QModbusReply::finished, this, [subreply, this, i](){
                                if(subreply->error() != QModbusDevice::NoError)
                                {
                                    QMessageBox msgBox;
                                    msgBox.setText(tr("Не удалось изменить чётность платы %1.").arg(i));
                                    msgBox.setStandardButtons(QMessageBox::Ok);
                                    msgBox.setDefaultButton(QMessageBox::Ok);
                                    int ret = msgBox.exec();
                                }
                            });
                        else
                        {
                            QMessageBox msgBox;
                            msgBox.setText(tr("Не удалось изменить чётность платы %1.").arg(i));
                            msgBox.setStandardButtons(QMessageBox::Ok);
                            msgBox.setDefaultButton(QMessageBox::Ok);
                            int ret = msgBox.exec();
                            delete subreply; // broadcast replies return immediately
                        }
                    } else {
                        QMessageBox msgBox;
                        msgBox.setText(tr("Не удалось изменить чётность платы %1.").arg(i));
                        msgBox.setStandardButtons(QMessageBox::Ok);
                        msgBox.setDefaultButton(QMessageBox::Ok);
                        int ret = msgBox.exec();
                    }
                }
            });
        else
            delete reply; // broadcast replies return immediately
        }
    }
}

bool M3KTE::pingNetworkDevices()
{
    int i=0;
    QTimer *timer = new QTimer(this);
    connect(timer, &QTimer::timeout, this, &M3KTE::timeForPingIsGone);
    timer->setSingleShot(true);
    QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::InputRegisters, 85, 1);
    int tmp_adr = 1;

    bool isRun = false;
    bool *tmp_isRun = &isRun;
    auto bar = new QProgressDialog(this);
    connect(bar, &QProgressDialog::canceled, this, [this, tmp_isRun]()
    {
        *tmp_isRun = true;
    });
    bar->setLabelText(tr("Поиск плат..."));
    bar->setCancelButton(nullptr);
    bar->setRange(0, 4);
    bar->setMinimumDuration(100);
    bar->setValue(i);

    CurrentConnectedDevice = 0;

    for(i=0; i<4;)
    {

        if(isRun && CurrentConnectedDevice < 1)
        {
            onConnectClicked();
            return false;
        }
        else if(isRun)
        {
            break;
        }
        timerForPingSignal = false;
        timer->start(m_settingsDialog->settings().responseTime);
        auto *reply = modbusDevice->sendReadRequest(*_unit, tmp_adr);
        while(!reply->isFinished() && !timerForPingSignal)
        {
            if(isRun && CurrentConnectedDevice < 1)
            {
                onConnectClicked();
                return false;
            }
            else if(isRun)
            {
                break;
            }
            QCoreApplication::processEvents();
        }
        if(timerForPingSignal)
        {

        }
        else
        {
            if(reply->error()==QModbusDevice::NoError)
            {
                timer->stop();
                CurrentConnectedDevice++;
                Boards[i].adr = Boards[i]._tmp_adr = tmp_adr;
                statusBar()->showMessage(tr("Плата %1 найдена по адресу %2.").arg(i).arg(tmp_adr), m_settingsDialog->settings().responseTime);
                i++;
                bar->setValue(i);
            }
        }
        tmp_adr++;
        bar->setLabelText(tr("Поиск плат... Текущий адрес: %1").arg(tmp_adr));
        if(tmp_adr>=247 && (CurrentConnectedDevice<1))
        {
            //ERROR
            //OUT OF RANGE
            QMessageBox::warning(this, "Ошибка при сканировании сети.", QString("Выход за пределы допустимых адресов. Найдено %1 плат.").arg(i));
            bar->setValue(4);
            bar->deleteLater();
            onConnectClicked();
            return false;
        }
        else if(tmp_adr>=247)
        {
            break;
        }
    }
    isRun=false;
    QMessageBox::warning(this, "Сканирование сети завершено.", tr("Найдено плат: %1 из 4.").arg(i));
    if(isRun)
    {
        onConnectClicked();
        return false;
    }

    bar->setLabelText(tr("Считывание текущих настроек..."));

    bar->setRange(0, CurrentConnectedDevice*3);
    QModbusDataUnit* _unit_settings[3];
    _unit_settings[0] = new QModbusDataUnit(QModbusDataUnit::Coils, 0, 85);
    _unit_settings[1] = new QModbusDataUnit(QModbusDataUnit::HoldingRegisters, 0, 85);
    _unit_settings[2] = new QModbusDataUnit(QModbusDataUnit::HoldingRegisters, 85, 85);

    for(i=0; i<CurrentConnectedDevice; i++)
    {
        for (int j = 0; j<3; j++)
        {
            bar->setValue(i*3+j);
            if(isRun)
            {
                onConnectClicked();
                return false;
            }

            timerForPingSignal = false;
            timer->start(m_settingsDialog->settings().responseTime);
            auto *reply = modbusDevice->sendReadRequest(*_unit_settings[j], Boards[i].adr);
            while(!reply->isFinished() && !timerForPingSignal)
            {
                if(isRun)
                {
                    onConnectClicked();
                    return false;
                }
                QCoreApplication::processEvents();
            }
            if(timerForPingSignal)
            {
                QMessageBox::warning(this, "Ошибка при получении текущих настроек.", QString("Таймаут при опросе устройства %1 по адресу %2").arg(i).arg(Boards[i].adr));
                onConnectClicked();
                return false;
            }
            else
            {
                if(reply->error()==QModbusDevice::NoError)
                {
                    timer->stop();
                    stepForScanCurrentSettings(reply);
                }
                else
                {
                    QMessageBox::warning(this, "Ошибка при получении текущих настроек.", QString("Таймаут при опросе устройства %1 по адресу %2").arg(i).arg(Boards[i].adr));
                    bar->setValue(CurrentConnectedDevice*3);
                    onConnectClicked();
                    return false;
                }
            }
        }
    }
    beginScanBoards();
    bar->deleteLater();
    return true;

}

void M3KTE::timeForPingIsGone()
{
    timerForPingSignal=true;
}

void M3KTE::beginScanBoards()
{
    if(CurrentConnectedDevice>=1)
        firstBoardScan();
    if(CurrentConnectedDevice>=2)
        secondBoardScan();
    if(CurrentConnectedDevice>=3)
        thirdBoardScan();
    if(CurrentConnectedDevice>=4)
        fourthBoardScan();
    return;
}

void M3KTE::firstBoardScan()
{
    if (!modbusDevice)
        return;

        QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::InputRegisters, 0, 85);
        statusBar()->clearMessage();

        if (auto *reply = modbusDevice->sendReadRequest(*_unit, Boards[0].adr)) {
            if (!reply->isFinished())
                connect(reply, &QModbusReply::finished, this, &M3KTE::firstBoardReady);
            else
                delete reply; // broadcast replies return immediately
        } else {
            QMessageBox::warning(this, QString("Ошибка при опросе платы #%1").arg(1), QString(tr("Read error: ") + modbusDevice->errorString()));
            statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
        }
}

void M3KTE::secondBoardScan()
{
    if (!modbusDevice)
        return;

            QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::InputRegisters, 0, 85);
        statusBar()->clearMessage();

        if (auto *reply = modbusDevice->sendReadRequest(*_unit, Boards[1].adr)) {
            if (!reply->isFinished())
                connect(reply, &QModbusReply::finished, this, &M3KTE::secondBoardReady);
            else
                delete reply; // broadcast replies return immediately
        } else {
            QMessageBox::warning(this, QString("Ошибка при опросе платы #%1").arg(2), QString(tr("Read error: ") + modbusDevice->errorString()));
            statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
        }
}

void M3KTE::thirdBoardScan()
{
    if (!modbusDevice)
        return;

            QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::InputRegisters, 0, 85);
        statusBar()->clearMessage();

        if (auto *reply = modbusDevice->sendReadRequest(*_unit, Boards[2].adr)) {
            if (!reply->isFinished())
                connect(reply, &QModbusReply::finished, this, &M3KTE::thirdBoardReady);
            else
                delete reply; // broadcast replies return immediately
        } else {
            QMessageBox::warning(this, QString("Ошибка при опросе платы #%1").arg(3), QString(tr("Read error: ") + modbusDevice->errorString()));
            statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
        }
}

void M3KTE::fourthBoardScan()
{
    if (!modbusDevice)
        return;

            QModbusDataUnit* _unit = new QModbusDataUnit(QModbusDataUnit::InputRegisters, 0, 85);
        statusBar()->clearMessage();

        if (auto *reply = modbusDevice->sendReadRequest(*_unit, Boards[3].adr)) {
            if (!reply->isFinished())
                connect(reply, &QModbusReply::finished, this, &M3KTE::fourthBoardReady);
            else
                delete reply; // broadcast replies return immediately
        } else {
            QMessageBox::warning(this, QString("Ошибка при опросе платы #%1").arg(4), QString(tr("Read error: ") + modbusDevice->errorString()));
            statusBar()->showMessage(tr("Read error: ") + modbusDevice->errorString(), 5000);
        }

}

void M3KTE::firstBoardReady()
{
    auto reply = qobject_cast<QModbusReply *>(sender());
    displayResultOfScan(reply, 0);
    reply->deleteLater();
    Boards[0].boardScanners->start(m_deviceSettingsDialog->currentBoardTimer(0));
}

void M3KTE::secondBoardReady()
{
    auto reply = qobject_cast<QModbusReply *>(sender());
    displayResultOfScan(reply, 1);
    reply->deleteLater();
    Boards[1].boardScanners->start(m_deviceSettingsDialog->currentBoardTimer(1));
}

void M3KTE::thirdBoardReady()
{
    auto reply = qobject_cast<QModbusReply *>(sender());
    displayResultOfScan(reply, 2);
    reply->deleteLater();
    Boards[2].boardScanners->start(m_deviceSettingsDialog->currentBoardTimer(2));
}

void M3KTE::fourthBoardReady()
{
    auto reply = qobject_cast<QModbusReply *>(sender());
    displayResultOfScan(reply, 3);
    reply->deleteLater();
    Boards[3].boardScanners->start(m_deviceSettingsDialog->currentBoardTimer(3));
}

void M3KTE::displayResultOfScan(QModbusReply *reply, int boardID)
{
    if (!reply)
        return;

    if (reply->error() == QModbusDevice::NoError) {

        const QModbusDataUnit unit = reply->result();
        bool W_Flag = false;
        bool A_Flag = false;
        if(unit.startAddress() != 0 || unit.valueCount() != 85)
        {
            //ERROR
            reply->deleteLater();
            QMessageBox::warning(this, QString("Ошибка при опросе платы #%1").arg(boardID), QString("Принятый ответ: Стартовый адрес %1, Количество элементов %2").arg(unit.startAddress()).arg(unit.valueCount()));
            return;
        }

        for(int i = unit.startAddress(), total = int(unit.valueCount()); i < total; ++i)
        {
            //QErrorMessage::showMessage()
            //if(Boards[boardID].ModbusModelCoil->data(Boards[boardID].ModbusModelCoil->index(i, 2), Qt::CheckStateRole).Bool != 0)
            //if(Boards[boardID].ModbusModelCoil->get_coil(Boards[boardID].ModbusModelCoil->index(i, 2))==true)
            if(Boards[boardID].coil[i]==true)
            {
                int j = 0;
                //if(Boards[boardID].ModbusModelHoldingReg->get_holreg(Boards[boardID].ModbusModelHoldingReg->index(85+i, 3)) > unit.value(i))
                if(Boards[boardID].HR[i + 85] > unit.value(i))
                {
                    j = 1;
                    m_ProgressBar[i+boardID*85]->setStatusTip(QString("П%1 ТЭ%2: Аварийный уровень напряжения.").arg(QString::number(boardID+1), QString::number(i%85)));
                    m_ProgressBar[i+boardID*85]->setWhatsThis(QString("П%1 ТЭ%2: Аварийный уровень напряжения.").arg(QString::number(boardID+1), QString::number(i%85)));
                    A_Flag = true;
                }
                //else if(Boards[boardID].ModbusModelHoldingReg->get_holreg(Boards[boardID].ModbusModelHoldingReg->index(i, 3)) > unit.value(i))
                else if(Boards[boardID].HR[i] > unit.value(i))
                {
                    j = 2;
                    m_ProgressBar[i+boardID*85]->setStatusTip(QString("П%1 ТЭ%2: Предупредительный уровень напряжения.").arg(QString::number(boardID+1), QString::number(i%85)));
                    m_ProgressBar[i+boardID*85]->setWhatsThis(QString("П%1 ТЭ%2: Предупредительный уровень напряжения.").arg(QString::number(boardID+1), QString::number(i%85)));
                    W_Flag = true;
                }
                else
                {
                    j = 3;
                    m_ProgressBar[i+boardID*85]->setStatusTip(QString("П%1 ТЭ%2: Уровень напряжения в норме.").arg(QString::number(boardID+1), QString::number(i%85)));
                    m_ProgressBar[i+boardID*85]->setWhatsThis(QString("П%1 ТЭ%2: Уровень напряжения в норме.").arg(QString::number(boardID+1), QString::number(i%85)));
                }
                m_ProgressBar[i+boardID*85]->setValue(j);
                QString style_fc = "QProgressBar {border: 2px solid black; font: bold 10px} QProgressBar::chunk {background: hsva(" + QString::number(j*50-50) + ", 255, 255, 100%);} ";
                m_ProgressBar[i+boardID*85]->setStyleSheet(style_fc);
            }
            else
            {
                m_ProgressBar[i+boardID*85]->setValue(3);
                m_ProgressBar[i+boardID*85]->setStatusTip(QString("П%1 ТЭ%2: Топливный Элемент не учитывается.").arg(QString::number(boardID+1), QString::number(i%85)));
                m_ProgressBar[i+boardID*85]->setWhatsThis(QString("П%1 ТЭ%2: Топливный Элемент не учитывается.").arg(QString::number(boardID+1), QString::number(i%85)));
                QString style_fc_off = "QProgressBar {border: 2px solid black; font: bold 10px} QProgressBar::chunk {background: hsva(" + QString::number(30) + ", 30, 30, 30%);} ";
                m_ProgressBar[i+boardID*85]->setStyleSheet(style_fc_off);
            }
            Boards[boardID].ModbusModelCoil->set_currentU(unit.value(i), i);
            Boards[boardID].ModbusModelHoldingReg->set_currentU(unit.value(i), i);
        }
        if(A_Flag)
            statusM3KTE.Accidents[boardID] = true;
        else
             statusM3KTE.Accidents[boardID] = false;
        if(W_Flag)
            statusM3KTE.Warnings[boardID] = true;
        else
            statusM3KTE.Warnings[boardID] = false;

        ui->BSM_Warning->setChecked(false);
        ui->BSM_Accident->setChecked(false);
        ui->BSM_WorkInProgress->setChecked(true);
        for(int i = 0; i < 4; i++)
        {
            if(statusM3KTE.Accidents[i])
            {
                ui->BSM_WorkInProgress->setChecked(false);
                ui->BSM_Warning->setChecked(false);
                ui->BSM_Accident->setChecked(true);
                break;
            }
            if(statusM3KTE.Warnings[i])
            {
                ui->BSM_WorkInProgress->setChecked(false);
                ui->BSM_Accident->setChecked(false);
                ui->BSM_Warning->setChecked(true);
            }
        }
    }   else if (reply->error() == QModbusDevice::ProtocolError) {
        statusBar()->showMessage(tr("Read response error: %1 (Mobus exception: 0x%2)").
                                    arg(reply->errorString()).
                                    arg(reply->rawResult().exceptionCode(), -1, 16), 5000);
    } else {
        statusBar()->showMessage(tr("Read response error: %1 (code: 0x%2)").
                                    arg(reply->errorString()).
                                    arg(reply->error(), -1, 16), 5000);
    }
    reply->deleteLater();
}

void M3KTE::stepForScanCurrentSettings(QModbusReply *reply)
{
        if (reply->error() == QModbusDevice::NoError) {
            const QModbusDataUnit unit = reply->result();
            int Adr = 255;
            for(int i = 0; i < 4; i++)
            {
                if(Boards[i].adr==reply->serverAddress())
                {
                    Adr = i;
                    break;
                }
            }
            for (int i = 0, total = int(unit.valueCount()); i < (total); ++i) {
                //ui->readValue->addItem(entry);
                if(unit.registerType() == QModbusDataUnit::Coils)
                {
                    Boards[Adr].coil[i + unit.startAddress()] = unit.value(i);
                    //QStandardItem *item = ui->writeValueTable->model()->item
                    if(unit.value(i)==1)
                    {
                        Boards[Adr].ModbusModelCoil->setData(ui->writeValueTable->model()->index(i + unit.startAddress(), 2), Qt::Checked, Qt::CheckStateRole);
                    }
                    else
                    {
                       Boards[Adr].ModbusModelCoil->setData(ui->writeValueTable->model()->index(i + unit.startAddress(), 2), Qt::Unchecked, Qt::CheckStateRole);
                    }

                }
                else if(unit.registerType() == QModbusDataUnit::HoldingRegisters)
                {
                    Boards[Adr].HR[i + unit.startAddress()] = unit.value(i);
                    Boards[Adr].ModbusModelHoldingReg->setData(Boards[Adr].ModbusModelHoldingReg->index(i + unit.startAddress(), 3), QString::number(unit.value(i), 16), Qt::EditRole);
                }
            }
        } else if (reply->error() == QModbusDevice::ProtocolError) {
            statusBar()->showMessage(tr("Read response error: %1 (Mobus exception: 0x%2)").
                                        arg(reply->errorString()).
                                        arg(reply->rawResult().exceptionCode(), -1, 16), 5000);
        } else {
            statusBar()->showMessage(tr("Read response error: %1 (code: 0x%2)").
                                        arg(reply->errorString()).
                                        arg(reply->error(), -1, 16), 5000);
        }

        reply->deleteLater();
}

void M3KTE::slotmultipleRegWrite()
{
    if (!modbusDevice)
        return;
    multipleRegWrite();
}

void M3KTE::slotmultipleRegWriteAndSend()
{
    if (!modbusDevice)
        return;
    multipleRegWrite();
    multipleRegSend();
}

void M3KTE::multipleRegSend()
{
    QModbusDataUnit *unit_tx = nullptr;
    if(m_regMultipleSettings->getTypeReg())
    {
        unit_tx = new QModbusDataUnit(QModbusDataUnit::HoldingRegisters, m_regMultipleSettings->getStartAdr(), m_regMultipleSettings->getCountReg());
    }
    else
    {
        unit_tx = new QModbusDataUnit(QModbusDataUnit::Coils, m_regMultipleSettings->getStartAdr(), m_regMultipleSettings->getCountReg());
    }
    for (unsigned i = 0; i < m_regMultipleSettings->getCountReg(); i++) {
        unit_tx->setValue(i, m_regMultipleSettings->getNewValue());
        if(m_regMultipleSettings->getTypeReg())
        {
            Boards[m_regMultipleSettings->getBoardId()].HR[i+m_regMultipleSettings->getStartAdr()] = m_regMultipleSettings->getNewValue();
        }
        else
        {
            Boards[m_regMultipleSettings->getBoardId()].coil[i+m_regMultipleSettings->getStartAdr()] = m_regMultipleSettings->getNewValue();
        }
    }

    if (auto *reply = modbusDevice->sendWriteRequest(*unit_tx, Boards[m_regMultipleSettings->getBoardId()].adr)) {
        if (!reply->isFinished()) {
            connect(reply, &QModbusReply::finished, this, [this, reply]() {
                if (reply->error() == QModbusDevice::ProtocolError) {
                    statusBar()->showMessage(tr("Write response error: %1 (Mobus exception: 0x%2)")
                        .arg(reply->errorString()).arg(reply->rawResult().exceptionCode(), -1, 16),
                        5000);
                } else if (reply->error() != QModbusDevice::NoError) {
                    statusBar()->showMessage(tr("Write response error: %1 (code: 0x%2)").
                        arg(reply->errorString()).arg(reply->error(), -1, 16), 5000);
                }
                reply->deleteLater();
            });
        } else {
            // broadcast replies return immediately
            reply->deleteLater();
        }
    } else {
        statusBar()->showMessage(tr("Write error: ") + modbusDevice->errorString(), 5000);
    }
}

void M3KTE::multipleRegWrite()
{
    for (unsigned i = 0; i < m_regMultipleSettings->getCountReg(); i++) {
        if(m_regMultipleSettings->getTypeReg())
        {
            //Boards[m_regMultipleSettings->getBoardId()].HR[i] = m_regMultipleSettings->getNewValue();
            Boards[m_regMultipleSettings->getBoardId()].ModbusModelHoldingReg->m_holdingRegisters[i+m_regMultipleSettings->getStartAdr()] = m_regMultipleSettings->getNewValue();
        }
        else
        {
            //Boards[m_regMultipleSettings->getBoardId()].coil[i] = m_regMultipleSettings->getNewValue();
            Boards[m_regMultipleSettings->getBoardId()].ModbusModelCoil->m_coils[i+m_regMultipleSettings->getStartAdr()] = (bool)m_regMultipleSettings->getNewValue();
        }
    }
}

void M3KTE::selectPositionOnTree(unsigned int index)
{
    ui->boardSelectBox->setCurrentIndex(index/85);
    QModelIndex selected = ui->writeValueTable->model()->index(index%85, 0);
    ui->writeValueTable->selectionModel()->select(selected, QItemSelectionModel::ClearAndSelect |QItemSelectionModel::Rows);
    ui->writeValueTable->scrollTo(selected);
    //selection
}
